// © 2021 Dag Langmyhr, Institutt for informatikk, Universitetet i Oslo

package no.uio.ifi.asp.parser;    

import no.uio.ifi.asp.main.*;
import no.uio.ifi.asp.runtime.*;
import no.uio.ifi.asp.scanner.*;
import static no.uio.ifi.asp.scanner.TokenKind.*;

class AspBooleanLiteral extends AspAtom {
    boolean value;

    AspBooleanLiteral(int n) {
	super(n);
    }


    @Override
    public String toString() {
        return (value ? "True" : "False");
    }


    static AspBooleanLiteral parse(Scanner s) {
	enterParser("boolean literal");

	AspBooleanLiteral abl = new AspBooleanLiteral(s.curLineNum());
	test(s, falseToken, trueToken);
	abl.value = (s.curToken().kind == trueToken);
	s.readNextToken();

	leaveParser("boolean literal");
	return abl;
    }


    @Override
    void prettyPrint() {
	prettyWrite(toString());
    }


    @Override
    RuntimeValue eval(RuntimeScope curScope) throws RuntimeReturnValue {
	return new RuntimeBoolValue(value);
    }
}
