// © 2021 Dag Langmyhr, Institutt for informatikk, Universitetet i Oslo

package no.uio.ifi.asp.parser;    

import no.uio.ifi.asp.main.*;
import no.uio.ifi.asp.runtime.*;
import no.uio.ifi.asp.scanner.*;
import static no.uio.ifi.asp.scanner.TokenKind.*;

class AspCompOpr extends AspSyntax {
    TokenKind kind;

    AspCompOpr(int n) {
	super(n);
    }


    static AspCompOpr parse(Scanner s) {
	enterParser("comp opr");

	AspCompOpr aco = new AspCompOpr(s.curLineNum());
	aco.kind = s.curToken().kind;
	s.readNextToken();

	leaveParser("comp opr");
	return aco;
    }


    @Override
    void prettyPrint() {
	prettyWrite(" " + kind + " ");
    }


    @Override
    RuntimeValue eval(RuntimeScope curScope) throws RuntimeReturnValue {
	Main.panic("AspCompOpr.eval should never be called directly!");
	return null;
    }
}
