// © 2021 Dag Langmyhr, Institutt for informatikk, Universitetet i Oslo

package no.uio.ifi.asp.parser;    

import no.uio.ifi.asp.main.*;
import no.uio.ifi.asp.scanner.*;
import static no.uio.ifi.asp.scanner.TokenKind.*;

abstract class AspCompoundStmt extends AspStmt {
    AspCompoundStmt(int n) {
	super(n);
    }


    static AspCompoundStmt parse(Scanner s) {
	enterParser("compound stmt");

	AspCompoundStmt as = null;
	switch (s.curToken().kind) {
	case defToken: 
	    as = AspFuncDef.parse(s);  break;
	case forToken:
	    as = AspForStmt.parse(s);  break;
	case ifToken: 
	    as = AspIfStmt.parse(s);  break;
	case whileToken: 
	    as = AspWhileStmt.parse(s);  break;
	default:
	    Main.panic("No compound statement found!", s.curLineNum());
	}

	leaveParser("compound stmt");
	return as;
    }
}
