// © 2021 Dag Langmyhr, Institutt for informatikk, Universitetet i Oslo

package no.uio.ifi.asp.parser;    

import no.uio.ifi.asp.main.*;
import no.uio.ifi.asp.runtime.*;
import no.uio.ifi.asp.scanner.*;
import static no.uio.ifi.asp.scanner.TokenKind.*;

class AspFactorOpr extends AspSyntax {
    TokenKind kind;

    AspFactorOpr(int n) {
	super(n);
    }


    static AspFactorOpr parse(Scanner s) {
	enterParser("factor opr");

	AspFactorOpr afo = new AspFactorOpr(s.curLineNum());
	afo.kind = s.curToken().kind;
	s.readNextToken();

	leaveParser("factor opr");
	return afo;
    }


    @Override
    void prettyPrint() {
	prettyWrite(" " + kind + " ");
    }


    @Override
    RuntimeValue eval(RuntimeScope curScope) throws RuntimeReturnValue {
	Main.panic("AspFactorOpr.eval should never be called directly!");
	return null;
    }
}
