// © 2021 Dag Langmyhr, Institutt for informatikk, Universitetet i Oslo

package no.uio.ifi.asp.parser;    

import no.uio.ifi.asp.main.*;
import no.uio.ifi.asp.runtime.*;
import no.uio.ifi.asp.scanner.*;
import static no.uio.ifi.asp.scanner.TokenKind.*;

class AspFactorPrefix extends AspSyntax {
    TokenKind kind;

    AspFactorPrefix(int n) {
	super(n);
    }


    static AspFactorPrefix parse(Scanner s) {
	enterParser("factor prefix");

	AspFactorPrefix afp = new AspFactorPrefix(s.curLineNum());
	afp.kind = s.curToken().kind;
	s.readNextToken();

	leaveParser("factor prefix");
	return afp;
    }


    @Override
    void prettyPrint() {
	prettyWrite(kind + " ");
    }


    @Override
    RuntimeValue eval(RuntimeScope curScope) throws RuntimeReturnValue {
	Main.panic("AspFactorPrefix.eval should never be called directly!");
	return null;
    }
}
