// © 2021 Dag Langmyhr, Institutt for informatikk, Universitetet i Oslo

package no.uio.ifi.asp.parser;    

import no.uio.ifi.asp.main.*;
import no.uio.ifi.asp.runtime.*;
import no.uio.ifi.asp.scanner.*;
import static no.uio.ifi.asp.scanner.TokenKind.*;

class AspFloatLiteral extends AspAtom {
    double value;

    AspFloatLiteral(int n) {
	super(n);
    }


    static AspFloatLiteral parse(Scanner s) {
	enterParser("float literal");

	AspFloatLiteral afl = new AspFloatLiteral(s.curLineNum());
	afl.value = s.curToken().floatLit;
	skip(s, floatToken);

	leaveParser("float literal");
	return afl;
    }


    @Override
    void prettyPrint() {
	prettyWrite("" + value);
    }


    @Override
    RuntimeValue eval(RuntimeScope curScope) throws RuntimeReturnValue {
	return new RuntimeFloatValue(value);
    }
}
