// © 2021 Dag Langmyhr, Institutt for informatikk, Universitetet i Oslo

package no.uio.ifi.asp.parser;    

import java.util.ArrayList;

import no.uio.ifi.asp.main.*;
import no.uio.ifi.asp.runtime.*;
import no.uio.ifi.asp.scanner.*;
import static no.uio.ifi.asp.scanner.TokenKind.*;

class AspListDisplay extends AspAtom {
    ArrayList<AspExpr> eList = new ArrayList<>();

    AspListDisplay(int n) {
	super(n);
    }


    static AspListDisplay parse(Scanner s) {
	enterParser("list display");

	AspListDisplay ald = new AspListDisplay(s.curLineNum());
	skip(s, leftBracketToken);
	if (s.curToken().kind != rightBracketToken) {
	    while (true) {
		ald.eList.add(AspExpr.parse(s));
		if (s.curToken().kind == rightBracketToken) break;
		skip(s, commaToken);
	    }
	}
	skip(s, rightBracketToken);

	leaveParser("list display");
	return ald;
    }


    @Override
    void prettyPrint() {
	prettyWrite("[");
	for (int i = 0;  i < eList.size();  ++i) {
	    if (i > 0) prettyWrite(", ");
	    eList.get(i).prettyPrint();
	}
	prettyWrite("]");
    }


    @Override
    RuntimeValue eval(RuntimeScope curScope) throws RuntimeReturnValue {
	RuntimeListValue res = new RuntimeListValue();
	for (AspExpr e: eList) {
	    res.addElem(e.eval(curScope));
	}
	return res;
    }
}
