// © 2021 Dag Langmyhr, Institutt for informatikk, Universitetet i Oslo

package no.uio.ifi.asp.parser;    

import no.uio.ifi.asp.main.*;
import no.uio.ifi.asp.runtime.*;
import no.uio.ifi.asp.scanner.*;
import static no.uio.ifi.asp.scanner.TokenKind.*;

public class AspName extends AspAtom {
    public String id;

    AspName(int n) {
	super(n);
    }


    static AspName parse(Scanner s) {
	enterParser("name");

	test(s, nameToken);
	AspName an = new AspName(s.curLineNum());
	an.id = s.curToken().name;
	skip(s, nameToken);

	leaveParser("name");
	return an;
    }


    @Override
    void prettyPrint() {
	prettyWrite(id);
    }


    @Override
    RuntimeValue eval(RuntimeScope curScope) throws RuntimeReturnValue {
	return curScope.find(id,this);
    }
}
