// © 2021 Dag Langmyhr, Institutt for informatikk, Universitetet i Oslo

package no.uio.ifi.asp.parser;    

import no.uio.ifi.asp.main.*;
import no.uio.ifi.asp.runtime.*;
import no.uio.ifi.asp.scanner.*;
import static no.uio.ifi.asp.scanner.TokenKind.*;

class AspNotTest extends AspSyntax {
    boolean withNot = false;
    AspComparison comp;

    AspNotTest(int n) {
	super(n);
    }


    static AspNotTest parse(Scanner s) {
	enterParser("not test");

	AspNotTest ant = new AspNotTest(s.curLineNum());
	if (s.curToken().kind == notToken) {
	    ant.withNot = true;
	    skip(s, notToken);
	}
	ant.comp = AspComparison.parse(s);

	leaveParser("not test");
	return ant;
    }


    @Override
    void prettyPrint() {
	if (withNot) 
	    prettyWrite("not ");
	comp.prettyPrint();
    }


    @Override
    RuntimeValue eval(RuntimeScope curScope) throws RuntimeReturnValue {
	RuntimeValue v = comp.eval(curScope);
	if (withNot) {
	    v = v.evalNot(this);
	}
	return v;
    }
}
