// © 2021 Dag Langmyhr, Institutt for informatikk, Universitetet i Oslo

package no.uio.ifi.asp.parser;    

import no.uio.ifi.asp.main.*;
import no.uio.ifi.asp.runtime.*;
import no.uio.ifi.asp.scanner.*;
import static no.uio.ifi.asp.scanner.TokenKind.*;

class AspReturnStmt extends AspSmallStmt {
    AspExpr retVal; 

    AspReturnStmt(int n) {
	super(n);
    }


    static AspReturnStmt parse(Scanner s) {
	enterParser("return stmt");

	AspReturnStmt ars = new AspReturnStmt(s.curLineNum());
	skip(s, returnToken);  ars.retVal = AspExpr.parse(s);

	leaveParser("return stmt");
	return ars;
    }


    @Override
    void prettyPrint() {
	prettyWrite("return ");  retVal.prettyPrint();
    }


    @Override
    RuntimeValue eval(RuntimeScope curScope) throws RuntimeReturnValue {
	RuntimeValue v = retVal.eval(curScope);
	trace("return "+v.showInfo());
	throw new RuntimeReturnValue(v,lineNum);
    }
}
