// © 2021 Dag Langmyhr, Institutt for informatikk, Universitetet i Oslo

package no.uio.ifi.asp.parser;    

import no.uio.ifi.asp.main.*;
import no.uio.ifi.asp.runtime.*;
import no.uio.ifi.asp.scanner.*;
import static no.uio.ifi.asp.scanner.TokenKind.*;

class AspSubscription extends AspPrimarySuffix {
    AspExpr index;

    AspSubscription(int n) {
	super(n);
    }


    static AspSubscription parse(Scanner s) {
	enterParser("subscription");

	AspSubscription as = new AspSubscription(s.curLineNum());
	skip(s, leftBracketToken);
	as.index = AspExpr.parse(s);
	skip(s, rightBracketToken);

	leaveParser("subscription");
	return as;
    }


    @Override
    void prettyPrint() {
	prettyWrite("[");  index.prettyPrint();  prettyWrite("]");
    }


    @Override
    RuntimeValue eval(RuntimeScope curScope) throws RuntimeReturnValue {
	return index.eval(curScope);
    }
}
