// © 2021 Dag Langmyhr, Institutt for informatikk, Universitetet i Oslo

package no.uio.ifi.asp.parser;    

import no.uio.ifi.asp.main.*;
import no.uio.ifi.asp.runtime.*;
import no.uio.ifi.asp.scanner.*;
import static no.uio.ifi.asp.scanner.TokenKind.*;

class AspTermOpr extends AspSyntax {
    TokenKind kind;

    AspTermOpr(int n) {
	super(n);
    }


    static AspTermOpr parse(Scanner s) {
	enterParser("term opr");

	AspTermOpr ato = new AspTermOpr(s.curLineNum());
	ato.kind = s.curToken().kind;
	s.readNextToken();

	leaveParser("term opr");
	return ato;
    }


    @Override
    void prettyPrint() {
	prettyWrite(" " + kind + " ");
    }


    @Override
    RuntimeValue eval(RuntimeScope curScope) throws RuntimeReturnValue {
	Main.panic("AspTermOpr.eval should never be called directly!");
	return null;
    }
}
